#INCLUDE "/BASIC/INCLUDES/STANDARD.BI"
#INCLUDE "/BASIC/INCLUDES/DIRSUBS.BI"

MyRootDir$=""

SET.ThinCP437:
   PRINT "{ISO ON}
   REM SET ISO THIN FONT
   POKE A.REG, 6
   SYS SET.CHARSET
   POKE $9F20, $08
   POKE $9F21, $F1
   POKE $9F22, %00010001
   POKE R0L,$23
   POKE R0H,$9F
   POKE R1L,$00
   POKE R1H,$BC
   POKE R2L, 0
   POKE R2H, $03
   BANK SAVEBANK
   SYS MEM.COPY
   POKE A.REG, 7
   SYS SET.CHARSET
   POKE $9F20, $08
   POKE $9F21, $F1
   POKE $9F22, %00010001
   POKE R1L,$23
   POKE R1H,$9F
   POKE R0L,$00
   POKE R0H,$BC
   POKE R2L, 0
   POKE R2H, $03
   BANK SAVEBANK
   SYS MEM.COPY
   ## HERE We grab a single PETSCII character back to the Font.. The DIAMOND
     OB=PEEK(1):BANK PEEK(0),6:CA=$C2D0:VA=$F748
       FOR I=0 TO 7
           X=PEEK(CA+I):VPOKE 1,VA+I,X
       NEXT I
   BANK PEEK(0),OB
   GOTO FIXCURSOR

SET.VGATextColors:
   POKE $9F20, 0
   POKE $9F21, $FA
   POKE $9F22, %00010001
   RESTORE VGATEXTCOLORS
   FOR I=0 TO 31:READ C:POKE $9F23, C:NEXT
   RETURN

#INCLUDE "VGATEXT.BI"

STORE.CONTROLVARS:
   BANK SAVEBANK
   S$="VOLUMECONTROL"
   SAddr = $A000
   GOSUB POKE.STRING
   S$=MyRootDir$
   SAddr = $A100:GOSUB POKE.STRING
   S$=TargetDir$
   SAddr = $A200:GOSUB POKE.STRING
   RETURN

GET.CONTROLVARS:
   BANK SAVEBANK
   SAddr = $A000
   GOSUB PEEK.STRING
   MY.ID$=S$
   SAddr = $A100
   GOSUB PEEK.STRING
   MyRootDir$= S$
   SAddr=$A200
   GOSUB PEEK.STRING
   TargetDir$=S$
   RETURN

CLEAR.CONTROLVARS:
    BANK SaveBank
    S$=RPT$(32,100)
    FOR A = $A000 TO $A500 STEP $100
        SAddr = A
        GOSUB POKE.STRING
    NEXT A
    RETURN
   
STORE.SystemState:
   SAVEDMODE=0:RETURN
   BANK SaveBank   
   GOSUB SAVE.SCREEN.MODE
   POKE $A500, SAVEDMODE
   POKE $A502, PEEK(COLOR.BYTE)
   POKE $A504, PEEK($372)
   RETURN

RESTORE.SystemState:
   RETURN
   BANK SaveBank
   POKE COLOR.BYTE, PEEK($A502)
   SAVEDMODE = PEEK($A500)
   SCREEN SAVEDMODE
   CharMode = PEEK($A504)
   IF (CharMode AND %01000000) = %01000000 THEN PRINT "{ISO ON}":RETURN
   PRINT "{ISO OFF}"
   IF (CharMode AND %00000001) THEN PRINT "{LOWER}":RETURN
   PRINT "{UPPER}"
   RETURN


