#CONTROLCODES 1
#INCLUDE "BOOKS.DEF"

SCREEN 0:COLOR 1,0:CLS
PRINT "{ISO ON}"

PRINT
RESTORE FILELIST.MANDATORY
READ CHECKFILE$
FOR I=0 TO -1 STEP 0
    PRINT "{WHT}Checking for: {LIGHT GREEN}";CHECKFILE$;"{YEL}..";
    F$=CHECKFILE$:GOSUB FILEEXISTS
    IF FE% THEN PRINT "Found..{LIGHT GREEN}!{WHT}"
    IF NOT FE% THEN FILE.NOT.FOUND
    IF RIGHT$(CHECKFILE$,4)=".BIN" THEN GOSUB LOADIT
    READ CHECKFILE$
    I=(CHECKFILE$="DONEFILES")
    PRINT
NEXT

PRINT "{WHT}{CR}{CR}"
PRINT "{LIGHT GREEN}  LOADING MACHINE LANGUAGE HELPERS"
PRINT "{YEL}  --------------------------------"
PRINT "{WHT}{CR}"
PRINT "{WHT}SPRITE GRAB ROUTINE: {LIGHT GREEN}";
RESTORE BVGRABSPRITE:GOSUB POKEMLROUTINE

PRINT "{WHT}GRAPHICS SCREEN SAVER ROUTINE: {LIGHT GREEN}";
RESTORE BVSAVE:GOSUB POKEMLROUTINE

PRINT "{WHT}STOP HANDLER ROUTINE: {LIGHT GREEN}";
RESTORE STOPHANDLER
GOSUB POKEMLROUTINE


SYS $0620

PRINT "{WHT}{CR}{CR}"
PRINT "{WHT}Load Volume Control"
LOAD "BOOKMENU.PRG"
END




LOADIT:
 READ BankNum
 READ Addr
 PRINT "{WHT}Loading {LIGHT GREEN}";CHECKFILE$;"{YELLOW} BANK:{LIGHT RED}";HEX$(BankNum);"{YELLOW} Addr:{LIGHT RED}";HEX$(Addr)
 BLOAD CHECKFILE$,DEVICE,BankNum,Addr
 RETURN

POKEMLROUTINE:
  READ PAddr
  READ C
  FOR I = 0 TO -1 STEP 0
      PRINT ".";
      POKE PAddr, C
      PAddr = PAddr + 1
      READ C
      I = (C<0)
  NEXT
  PRINT:PRINT
  RETURN


## 48 BYTES
STOPHANDLER:
DATA $620,234,173,40,3,141,70,6,173,41,3,141,71,6,120,169,69,141,40,3,169,6,141,41,3,173,32,6,141,75,6,169,96,141,32,6,88,96,32,255,255,169,3,96,96,120,173,70,6,141,40,3,173,71,6,141,41,3,173
DATA 75,6,141,32,6,169,96,141,75,6,88,96,-1

## 29 BYTES
BVGRABSPRITE:
  DATA $600,$20,$C9,$FF,$20,$FF,$FE,$A2,$23,$A0,$9F,$A9,$40,$38,$20,$B1,$FE
  DATA $C6,$20,$F0,$05,$20,$02,$FF,$80,$ED,$20,$CC,$FF,$60,-1

## 75 BYTES
BVSAVE:
   DATA $700,$AA,$20,$C9,$FF,$9C,$4B,$07,$A9,$2C,$8D,$4C,$07,$A9,$01,$8D,$4D,$07,$A2
   DATA $23,$A0,$9F,$AD,$4B,$07,$38,$20,$B1,$FE,$B0,$29,$8E,$4E,$07,$AD,$4B,$07
   DATA $38,$ED,$4E,$07,$8D,$4B,$07,$AD,$4C,$07,$8C,$4E,$07,$ED,$4E,$07,$8D,$4C
   DATA $07,$AD,$4D,$07,$E9,0,$8D,$4D,$07,$0D,$4B,$07,$0D,$4C,$07,$D0,$CA,$20
   DATA $CC,$FF,$60,-1

FILELIST.MANDATORY:
 DATA "BMXA000.BIN",4,$A000,"WAVMODULE.BIN",3,$A000,"SHELLSORT.BIN",1,$400,"PLAYBOOK.PRG","BOOKMENU.PRG","T1.SPR","T2.SPR","T3.SPR"
 DATA "DONEFILES"

FILELIST.OPTIONAL:
 DATA "DPAL.BIN"


FILE.NOT.FOUND:
  PRINT "{BELL}":PRINT:PRINT:PRINT:PRINT "{BELL}"
  PRINT "{LIGHT RED}";CHECKFILE$;"{WHT} NOT FOUND !"
  PRINT
  PRINT "PLEASE CHECK YOUR INSTALLATION"
  END


#INCLUDE "BOOKS.BI"
